AC_INIT()

AC_ARG_ENABLE([debugging], 	 [  --enable-debugging                enable -g when compiling ])
AC_ARG_ENABLE([64bit], 	 [  --enable-64bit                enable 64bit binary analysis ])
AC_ARG_ENABLE([reducedanalysis], [  --enable-reducedanalysis          reduce the amount of in-depth analysis (useful for large programs that exhaust memory)])



AC_CANONICAL_HOST

EXTRA_CXXFLAGS=-O3 
CXX=g++
LD=g++
PLUGIN_NAME=SMPStaticAnalyzer.plx

if test "$enable_debugging" = yes; then 
	EXTRA_CXXFLAGS=-g
fi

EXTRA_CXXFLAGS="${EXTRA_CXXFLAGS}  \
	-I${SMPSA_HOME}/include  \
	-I${SMPSA_HOME}/include/base  \
	-I${SMPSA_HOME}/include/interfaces  \
	-I${SMPSA_HOME}/include/interfaces/abstract \
	-I${SMPSA_HOME}/include/interfaces/idapro \
	-I${IDASDK}/include \
	-D__IDP__ -D__PLUGIN__ -D__LINUX__ -DSTARS_IDA_INTERFACE -w  -m32 --short-enums \
	" 

if test "$enable_reducedanalysis" = yes; then 
	EXTRA_CXXFLAGS="${EXTRA_CXXFLAGS} -DSMP_REDUCED_ANALYSIS"
fi

if test ! "$enable_64bit" = no; then
	echo Enabling 64-bit IDAPRO support.
   	EXTRA_CXXFLAGS="${EXTRA_CXXFLAGS} -D__EA64__"
   	PLUGIN_NAME=SMPStaticAnalyzer.plx64
fi

STARS_HOME=$SMPSA_HOME

AC_SUBST(EXTRA_CXXFLAGS)
AC_SUBST(CXX)
AC_SUBST(LD)
AC_SUBST(PLUGIN_NAME)
AC_SUBST(STARS_HOME)

AC_OUTPUT(Makefile
	src/Makefile
	src/base/Makefile
	src/interfaces/Makefile
	src/interfaces/idapro/Makefile
	src/interfaces/irdb/Makefile
	lib/Makefile
	scripts/Makefile
)
